/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servlet;

import applicationcontroler.ApplicationControler;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import webpageresolver.WebPageResolver;

/**
 *
 * @author student
 */
public class FrontControlerServlet extends HttpServlet {

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequestGet(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequestPost(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private void processRequestPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String action = request.getParameter("akcija");
        System.out.println("\n akcija=" + action);
        System.out.println("\nPOST");

        String page = ApplicationControler.getApplicationControler().processRequest(request, action);
        String webPage = WebPageResolver.lookUp(page);
        RequestDispatcher dispatcher = request.getRequestDispatcher(webPage);
        dispatcher.forward(request, response);
    }

    private void processRequestGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String action = request.getParameter("akcija");
        System.out.println("\n akcija=" + action);
        System.out.println("\nGET");

        String page = ApplicationControler.getApplicationControler().processRequest(request, action);
        System.out.println("\n page=" + page);
        String webPage = WebPageResolver.lookUp(page);

        RequestDispatcher dispatcher = request.getRequestDispatcher(webPage);
        dispatcher.forward(request, response);
    }

}
